#91 gringo: test failures on fedora 21

gringo-4.x
closed
None
4
2015-01-13
2014-04-24
Scott Logan
No

There is a test failure on Fedora 21 (this test succeeds on F19 and F20)

Using gringo 4.3.0

build/debug/test_libgringo
.......................................................................................................F...................................................................
libgringo/tests/ground/instantiation.cc:335:Assertion
Test name: N6Gringo6Ground4Test17TestInstantiationE::test_min_true
equality assertion failed
- Expected: [-:27:39-40: warning: atom is undefined:
  b
,-:26:39-40: warning: atom is undefined:
  b
]
- Actual  : [-:26:39-40: warning: atom is undefined:
  b
,-:27:39-40: warning: atom is undefined:
  b
]
Failures !!!
Run: 170   Failure total: 1   Failures: 1   Errors: 0
scons: *** [test] Error 1
scons: building terminated because of errors.

Discussion

  • This should not happen. Can you give me a bit more info to investigate please? I guess you are using Fedora rawhide? Do you use the x86 or x86_64 (or other) arch? Also can you send me the scons configuration file (build/debug.py or build/release.py).

     
  • Scott Logan
    Scott Logan
    2014-04-25

    Thanks for getting back to me so quickly.

    I am using Fedora rawhide, and the failure happens for both x86 and x86_64. The end goal is packaging clasp/gringo/clingo for Fedora proper. I'll submit review requests when I stabilize this bug.

    Attached debug.py

     
    Attachments
    • status: open --> accepted
     
  • This happens because I am looping over an unordered_map. The order depends of course on the implementation. This can result in warnings printed in a different order. I'll check how to fix this.

     
    Last edit: Roland Kaminski 2014-04-25
    • assigned_to: rkaminski
     
  • Here is a patch. The affected warnings will be sorted by occurrence now.

     
  • Btw.: In your CXXFLAGS you are passing first -O2 and then -O3. If I remember correctly -O2 will be overwritten with -O3 in this case.

     
  • Scott Logan
    Scott Logan
    2014-04-25

    Fix looks good, thanks.

    As for the CXXFLAGS, the system's flags were setting -O2 and I added -O3 manually because it was in the suggested flags. I removed the -O3, so the build will use the system's suggested optimization level.

    Thanks again!

     
  • fixed in trunk

     
    • status: accepted --> closed